#!/usr/bin/env bash
#
# List installed packages that install a kernel module.
set -euo pipefail
IFS=$'\n\t'
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

: ${PORTSDIR:="/usr/ports"}

function main {
    if [ "$#" -ne 0 ]; then
        (>&2 echo "This script takes no positional parameters.")
        exit 1
    fi
    local module
    doas find / -type f -name '*.ko' | sort | while read module; do
        local provides=$(pkg provides "$module")
        if [ -n "$provides" ]; then
            package_name=$(grep 'Name    : ' <<<"$provides" | sed 's/Name    : //g')
            # module_file=$(grep 'Filename: ' <<<"$provides" | sed 's/Filename: //g')
            echo "$package_name"
        fi
    done
}

main "${@}"
